<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="流程名称" prop="procDefName">
        <el-input
          v-model="queryParams.procDefName"
          placeholder="请输入名称"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item label="流程类型" prop="category">
        <el-select
          v-model="queryParams.category"
          @keyup.enter.native="handleQuery"
          placeholder="请选择流程类型"
          clearable
        >
          <el-option
            v-for="dict in dict.type.sys_process_category"
            :key="dict.value"
            :label="dict.label"
            :value="dict.value"
          />
        </el-select>
      </el-form-item>
      <el-form-item label="接受时间">
        <el-date-picker
          v-model="daterangeCheckTime"
          style="width: 240px"
          value-format="yyyy-MM-dd"
          type="daterange"
          range-separator="-"
          start-placeholder="开始日期"
          end-placeholder="结束日期"
        ></el-date-picker>
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-table v-loading="loading" :data="todoList" @selection-change="handleSelectionChange" stripe>
      <el-table-column label="项目名称" align="center" prop="businessKeyName" width="250" :show-overflow-tooltip="true"/>
      <el-table-column label="流程编号" align="center" prop="taskId" width="120" :show-overflow-tooltip="true"/>
      <el-table-column label="流程名称" align="center" prop="procDefName" width="180" :show-overflow-tooltip="true"/>
      <el-table-column label="流程类别" align="center" prop="category" width="180">
        <template slot-scope="scope">
          <dict-tag
            :options="dict.type.sys_process_category"
            :value="scope.row.category"
          />
        </template>
      </el-table-column>
      <el-table-column label="当前节点" align="center" prop="taskName"/>
      <el-table-column label="流程版本" align="center" width="80">
        <template slot-scope="scope">
          <el-tag size="medium" >v{{scope.row.procDefVersion}}</el-tag>
        </template>
      </el-table-column>
      <el-table-column label="流程发起人" align="center" width="180">
        <template slot-scope="scope">
          <label>{{scope.row.startUserName}} <br/>
            <el-tag type="info" size="mini">{{scope.row.startDeptName}}</el-tag>
          </label>
        </template>
      </el-table-column>
      <el-table-column label="接收时间" align="center" prop="createTime" width="180"/>
      <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit-outline"
            @click="handleProcess(scope.row)"
          >处理
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination
      v-show="total>0"
      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />
    <editTaskDrawer ref="editTaskDrawer" :closeCallBack="getList"></editTaskDrawer>
    <editLeaveTaskDrawer ref="editLeaveTaskDrawer" :closeCallBack="getList"></editLeaveTaskDrawer>
    <approveDrawer ref="approveDrawer" :closeCallBack="getList"></approveDrawer>
    <approveLeaveDrawer ref="approveLeaveDrawer" :closeCallBack="getList"></approveLeaveDrawer>
  </div>
</template>
<script>
import {
  todoList,
  delDeployment,
} from "@/api/flowable/todo";
import {myAwaitFlowTaskList} from "@/api/flowable/businessKey";
import editTaskDrawer from "../myProcess/editTaskDrawer.vue";
import editLeaveTaskDrawer from '../myProcess/editLeaveTaskDrawer.vue'
import approveDrawer from "./detail/approveDrawer.vue";
import approveLeaveDrawer from "./detail/approveLeaveDrawer.vue";

export default {
  name: "Deploy",
  components: {approveDrawer,approveLeaveDrawer,editTaskDrawer,editLeaveTaskDrawer},
  dicts: ["sys_process_category"],
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 流程待办任务表格数据
      todoList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        procDefName: null,
        category: null,
        params: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {},
      daterangeCheckTime:[],
    };
  },
  created() {
    this.getList();
  },
  methods: {
    /** 查询流程定义列表 */
    getList() {
      this.loading = true;
      this.queryParams.params = {};
      if (null != this.daterangeCheckTime && "" != this.daterangeCheckTime) {
        this.queryParams.params["beginDate"] = this.daterangeCheckTime[0];
        this.queryParams.params["endDate"] = this.daterangeCheckTime[1];
      }
      //重新刷新代办任务
      this.$store.dispatch('settingAwaitNum');
      myAwaitFlowTaskList(this.queryParams).then(response => {
        this.todoList = response.rows;
        this.total = response.total;
        this.loading = false;
      });
    },
    // 跳转到处理页面
    handleProcess(row){
      if(row.taskName=="提交申请"){
        if(row.procDefKey=="flow_xmglzdl_qjspb"){
          this.$refs.editLeaveTaskDrawer.show(row);
        }else{
          this.$refs.editTaskDrawer.show(row);
        }
      }else{
        //根据不同业务跳转不同表单
        if(row.procDefKey=="flow_xmglzdl_qjspb"){
          this.$refs.approveLeaveDrawer.show(row);
        }else{
          this.$refs.approveDrawer.show(row);
        }
      }
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        name: null,
        category: null,
        key: null,
        tenantId: null,
        deployTime: null,
        derivedFrom: null,
        derivedFromRoot: null,
        parentDeploymentId: null,
        engineVersion: null
      };
      this.daterangeCheckTime=[];
      this.resetForm("form");
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.daterangeCheckTime=[];
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.taskId)
      this.single = selection.length !== 1
      this.multiple = !selection.length
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.taskId || this.ids;
      this.$confirm('是否确认删除流程定义编号为"' + ids + '"的数据项?', "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning"
      }).then(function () {
        return delDeployment(ids);
      }).then(() => {
        this.getList();
       this.$modal.msgSuccess("删除成功");
      })
    },
  }
};
</script>

